import { ChangeDetectorRef, ComponentFactoryResolver, EventEmitter, QueryList, Type, ViewContainerRef } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { DynamicFormArrayComponent, DynamicFormArrayGroupModel, DynamicFormArrayModel, DynamicFormComponentService, DynamicFormControl, DynamicFormControlContainerComponent, DynamicFormControlCustomEvent, DynamicFormControlEvent, DynamicFormControlLayout, DynamicFormControlModel, DynamicFormGroupComponent, DynamicFormGroupModel, DynamicFormLayout, DynamicFormLayoutService, DynamicFormRelationService, DynamicFormValidationService, DynamicTemplateDirective } from "@ng-dynamic-forms/core";
import * as i0 from "@angular/core";
export declare class DynamicNGxBootstrapFormControlContainerComponent extends DynamicFormControlContainerComponent {
    protected changeDetectorRef: ChangeDetectorRef;
    protected componentFactoryResolver: ComponentFactoryResolver;
    protected layoutService: DynamicFormLayoutService;
    protected validationService: DynamicFormValidationService;
    protected componentService: DynamicFormComponentService;
    protected relationService: DynamicFormRelationService;
    contentTemplateList?: QueryList<DynamicTemplateDirective>;
    klass?: string;
    asBootstrapFormGroup: boolean;
    context: DynamicFormArrayGroupModel | null;
    group: FormGroup;
    hostClass?: string[];
    inputTemplateList?: QueryList<DynamicTemplateDirective>;
    layout?: DynamicFormLayout;
    model: DynamicFormControlModel;
    blur: EventEmitter<DynamicFormControlEvent>;
    change: EventEmitter<DynamicFormControlEvent>;
    focus: EventEmitter<DynamicFormControlEvent>;
    customEvent: EventEmitter<DynamicFormControlEvent>;
    componentViewContainerRef: ViewContainerRef;
    get componentType(): Type<DynamicFormControl> | null;
    constructor(changeDetectorRef: ChangeDetectorRef, componentFactoryResolver: ComponentFactoryResolver, layoutService: DynamicFormLayoutService, validationService: DynamicFormValidationService, componentService: DynamicFormComponentService, relationService: DynamicFormRelationService);
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicNGxBootstrapFormControlContainerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DynamicNGxBootstrapFormControlContainerComponent, "dynamic-ngx-bootstrap-form-control", never, { "asBootstrapFormGroup": "asBootstrapFormGroup"; "context": "context"; "group": "group"; "hostClass": "hostClass"; "inputTemplateList": "templates"; "layout": "layout"; "model": "model"; }, { "blur": "blur"; "change": "change"; "focus": "focus"; "customEvent": "bsEvent"; }, ["contentTemplateList"], ["*"]>;
}
export declare function bootstrapUIFormControlMapFn(model: DynamicFormControlModel): Type<DynamicFormControl> | null;
export declare class DynamicNGxBootstrapFormArrayComponent extends DynamicFormArrayComponent {
    protected layoutService: DynamicFormLayoutService;
    protected validationService: DynamicFormValidationService;
    formLayout?: DynamicFormLayout;
    group: FormGroup;
    layout?: DynamicFormControlLayout;
    model: DynamicFormArrayModel;
    templates?: QueryList<DynamicTemplateDirective>;
    blur: EventEmitter<any>;
    change: EventEmitter<any>;
    customEvent: EventEmitter<DynamicFormControlCustomEvent>;
    focus: EventEmitter<any>;
    components: QueryList<DynamicNGxBootstrapFormControlContainerComponent>;
    constructor(layoutService: DynamicFormLayoutService, validationService: DynamicFormValidationService);
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicNGxBootstrapFormArrayComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DynamicNGxBootstrapFormArrayComponent, "dynamic-ngx-bootstrap-form-array", never, { "formLayout": "formLayout"; "group": "group"; "layout": "layout"; "model": "model"; "templates": "templates"; }, { "blur": "blur"; "change": "change"; "customEvent": "customEvent"; "focus": "focus"; }, never, never>;
}
export declare class DynamicNGxBootstrapFormGroupComponent extends DynamicFormGroupComponent {
    protected layoutService: DynamicFormLayoutService;
    protected validationService: DynamicFormValidationService;
    formLayout?: DynamicFormLayout;
    group: FormGroup;
    layout?: DynamicFormControlLayout;
    model: DynamicFormGroupModel;
    templates?: QueryList<DynamicTemplateDirective> | DynamicTemplateDirective[];
    blur: EventEmitter<any>;
    change: EventEmitter<any>;
    customEvent: EventEmitter<DynamicFormControlCustomEvent>;
    focus: EventEmitter<any>;
    components: QueryList<DynamicNGxBootstrapFormControlContainerComponent>;
    constructor(layoutService: DynamicFormLayoutService, validationService: DynamicFormValidationService);
    static ɵfac: i0.ɵɵFactoryDeclaration<DynamicNGxBootstrapFormGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DynamicNGxBootstrapFormGroupComponent, "dynamic-ngx-bootstrap-form-group", never, { "formLayout": "formLayout"; "group": "group"; "layout": "layout"; "model": "model"; "templates": "templates"; }, { "blur": "blur"; "change": "change"; "customEvent": "customEvent"; "focus": "focus"; }, never, never>;
}
